﻿-- Author      : Administrator
-- Create Date : 8/31/2014 7:48:52 PM
if select(2, UnitClass("player")) ~= "PRIEST" then return end

local L = iShieldDB_Translations
local _mConfig;
local _mBarLine;
local _mBarWidth;
local _mBarHight;
local _mBarColumn;
local _mBarColor;
local _mBarAlpha;
local _mCBModel;
local _mCBModel2;
local _mCBModel3;
local _mButtonLoc;
local _mButtonLocSpace;
local _mCBDoubleFlag;
local configSliderBackdrop  = {
	bgFile = "Interface\\Buttons\\UI-SliderBar-Background",
	edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
	tile = true, tileSize = 8, edgeSize = 8,
	insets = { left = 3, right = 3, top = 6, bottom = 6 }
}
local configFrameBackdrop ={ bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
						edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
						tile = true, tileSize = 16, edgeSize = 16, 
						insets = { left = 11, right = 12, top = 12, bottom = 11 }};
						
local _mConfigFrame = CreateFrame("Frame","Config",UIParent)




function BarLine_OnScrollValueChanged(_frame, _value)
	local nowVal =  math.ceil(_value);
	if nowVal ~= _mConfig.linespace then
		_mConfig.linespace = nowVal;
		SetValueConfig(_mConfig)
	end
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(nowVal));
end

function BarHight_OnScrollValueChanged(_frame, _value)
	local nowVal =  math.ceil(_value);
	if nowVal ~= _mConfig.barhigh then
		_mConfig.barhigh = nowVal;
		SetValueConfig(_mConfig)
	end
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(nowVal));
end

function BarWidth_OnScrollValueChanged(_frame, _value)
	local nowVal =  math.ceil(_value);
	if nowVal ~= _mConfig.barwidth then
		_mConfig.barwidth = nowVal;
		SetValueConfig(_mConfig)
	end
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(nowVal));
end

function BarColumn_OnScrollValueChanged(_frame, _value)
	local nowVal =  math.ceil(_value);
	if nowVal ~= _mConfig.columnspace then
		_mConfig.columnspace = nowVal;
		SetValueConfig(_mConfig)
	end
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(nowVal));
end

function BarAlpha_OnScrollValueChanged(_frame, _value)
	local nowVal = math.ceil(_value * 10)/10;
	--local nowVal =  math.ceil(_value);
	if nowVal ~= _mConfig.colora then
		_mConfig.colora = nowVal;
		SetValueConfig(_mConfig)
	end
end

function BarColor_OnScrollValueChanged(self)
	local nowValR,nowValG,nowValB = self:GetColorRGB();
	nowValR = math.ceil(nowValR * 100)/100;
	nowValG = math.ceil(nowValG * 100)/100;
	nowValB = math.ceil(nowValB * 100)/100;	
	if nowValR ~= _mConfig.colorr or nowValG ~= _mConfig.colorg or nowValB ~= _mConfig.colorb then
		_mConfig.colorr = nowValR;
		_mConfig.colorg = nowValG;
		_mConfig.colorb = nowValB;
		SetValueConfig(_mConfig)
	end
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(nowValR).." "..tostring(nowValG).." "..tostring(nowValB))
end

function ButtonLoc_OnScrollValueChanged(_frame, _value)
	local nowVal =  math.ceil(_value);
	if nowVal ~= _mConfig.buttonLoc then
		_mConfig.buttonLoc = nowVal;
		SetValueConfigButton(_mConfig);
	end
end

function ButtonLocSpace_OnScrollValueChanged(_frame, _value)
	local nowVal =  math.ceil(_value);
	if nowVal ~= _mConfig.buttonLocspace then
		_mConfig.buttonLocspace = nowVal;
		SetValueConfigButton(_mConfig);
	end
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(nowVal));
end


function CBModel3_OnClick()
	local nowVal = 0;
	if _mCBModel3:GetChecked() then
		nowVal = 1;
	end
	if nowVal ~= _mConfig.printmodel3 then
		_mConfig.printmodel3 = nowVal;
		SetValueConfigModel(_mConfig)
	end
end

function CBModel2_OnClick()
	local nowVal = 0;
	if _mCBModel2:GetChecked() then
		nowVal = 1;
	end
	if nowVal ~= _mConfig.printmodel2 then
		_mConfig.printmodel2 = nowVal;
		SetValueConfigModel(_mConfig)
	end
end

function CBModel_OnClick()
	local nowVal = 0;
	if _mCBModel:GetChecked() then
		nowVal = 1;
	end
	if nowVal ~= _mConfig.printmodel then
		_mConfig.printmodel = nowVal;
		SetValueConfigModel(_mConfig)
	end
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(nowVal));
end

function CBDoubleFlag_OnClick()
	local nowVal = 0;
	if _mCBDoubleFlag:GetChecked() then
		nowVal = 1;
	end
	if nowVal ~= _mConfig.backup.enabledflag then
		_mConfig.backup.enabledflag = nowVal;
		SetValueConfigButton(_mConfig)
	end
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(nowVal));
end


function configNewFrameBar()
	local labelTitle =_mConfigFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelTitle:SetPoint("TOP", 0, -20)
	labelTitle:SetJustifyH("LEFT")
	labelTitle:SetJustifyV("TOP")
	labelTitle:SetText("|cffff0000iShield|r");	
	
	_mCBDoubleFlag = CreateFrame("CheckButton",nil, _mConfigFrame, "UICheckButtonTemplate")
	_mCBDoubleFlag:SetPoint("TOPLEFT", 210, -90)
	_mCBDoubleFlag.type = "checkbox"
	_mCBDoubleFlag:SetChecked(true)
	_mCBDoubleFlag.text:SetText(L.TextDoubleFlag)
	_mCBDoubleFlag:SetScript("OnClick", CBDoubleFlag_OnClick)

	_mBarColor = CreateFrame("ColorSelect", nil, _mConfigFrame)
	_mBarColor.mytype = "colorselect";
	_mBarColor:SetWidth(128)
	_mBarColor:SetHeight(128)
	_mBarColor:SetPoint("TOPLEFT", 30, -60)
	local colorwheel = _mBarColor:CreateTexture()
	colorwheel:SetWidth(128)
	colorwheel:SetHeight(128)
	colorwheel:SetPoint("TOPLEFT", _mBarColor, "TOPLEFT", 5, 0)
	_mBarColor:SetColorWheelTexture(colorwheel)
	local colorwheelthumbtexture = _mBarColor:CreateTexture()
	colorwheelthumbtexture:SetTexture("Interface\\Buttons\\UI-ColorPicker-Buttons")
	colorwheelthumbtexture:SetWidth(10)
	colorwheelthumbtexture:SetHeight(10)
	colorwheelthumbtexture:SetTexCoord(0,0.15625, 0, 0.625)
	_mBarColor:SetColorWheelThumbTexture(colorwheelthumbtexture)
	_mBarColor:SetScript("OnColorSelect", BarColor_OnScrollValueChanged)

	local lableBarAlpha =_mConfigFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	lableBarAlpha:SetPoint("TOPLEFT", 210, -130)
	lableBarAlpha:SetJustifyH("LEFT")
	lableBarAlpha:SetJustifyV("TOP")
	lableBarAlpha:SetText(L.TextBarAlpha);	
	_mBarAlpha= CreateFrame("Slider", nil, _mConfigFrame)
	_mBarAlpha:SetOrientation("HORIZONTAL")
	_mBarAlpha:SetWidth(150)
	_mBarAlpha:SetHeight(14)
	_mBarAlpha:SetHitRectInsets(0, 0, -10, 0)
	_mBarAlpha:SetBackdrop(configSliderBackdrop)
	_mBarAlpha:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	_mBarAlpha:SetPoint("TOPLEFT", 210, -150)
	_mBarAlpha:SetMinMaxValues(0, 1.0)
	_mBarAlpha:SetValueStep(0.1)
	_mBarAlpha:SetValue(0.6)
	_mBarAlpha:SetScript("OnValueChanged", BarAlpha_OnScrollValueChanged)
	
	
	local labelBarHight =_mConfigFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelBarHight:SetPoint("TOPLEFT", 30, -190)
	labelBarHight:SetJustifyH("LEFT")
	labelBarHight:SetJustifyV("TOP")
	labelBarHight:SetText(L.TextBarHight);	
	_mBarHight= CreateFrame("Slider", nil, _mConfigFrame)
	_mBarHight:SetOrientation("HORIZONTAL")
	_mBarHight:SetWidth(150)
	_mBarHight:SetHeight(14)
	_mBarHight:SetHitRectInsets(0, 0, -10, 0)
	_mBarHight:SetBackdrop(configSliderBackdrop)
	_mBarHight:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	_mBarHight:SetPoint("TOPLEFT", 30, -210)
	_mBarHight:SetMinMaxValues(4, 100)
	_mBarHight:SetValueStep(1)
	_mBarHight:SetValue(70)
	_mBarHight:SetScript("OnValueChanged", BarHight_OnScrollValueChanged)
	
	
	local labelBarWidth =_mConfigFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelBarWidth:SetPoint("TOPLEFT", 210, -190)
	labelBarWidth:SetJustifyH("LEFT")
	labelBarWidth:SetJustifyV("TOP")
	labelBarWidth:SetText(L.TextBarWidth);	
	_mBarWidth= CreateFrame("Slider", nil, _mConfigFrame)
	_mBarWidth:SetOrientation("HORIZONTAL")
	_mBarWidth:SetWidth(150)
	_mBarWidth:SetHeight(14)
	_mBarWidth:SetHitRectInsets(0, 0, -10, 0)
	_mBarWidth:SetBackdrop(configSliderBackdrop)
	_mBarWidth:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	_mBarWidth:SetPoint("TOPLEFT", 210, -210)
	_mBarWidth:SetMinMaxValues(20, 100)
	_mBarWidth:SetValueStep(1)
	_mBarWidth:SetValue(70)
	_mBarWidth:SetScript("OnValueChanged", BarWidth_OnScrollValueChanged)
	
	local labelBarLine =_mConfigFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelBarLine:SetPoint("TOPLEFT", 30, -240)
	labelBarLine:SetJustifyH("LEFT")
	labelBarLine:SetJustifyV("TOP")
	labelBarLine:SetText(L.TextBarLineSpace);	
	_mBarLine= CreateFrame("Slider", nil, _mConfigFrame)
	_mBarLine:SetOrientation("HORIZONTAL")
	_mBarLine:SetWidth(150)
	_mBarLine:SetHeight(14)
	_mBarLine:SetHitRectInsets(0, 0, -10, 0)
	_mBarLine:SetBackdrop(configSliderBackdrop)
	_mBarLine:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	_mBarLine:SetPoint("TOPLEFT", 30, -260)
	_mBarLine:SetMinMaxValues(0, 50)
	_mBarLine:SetValueStep(1)
	_mBarLine:SetValue(0)
	_mBarLine:SetScript("OnValueChanged", BarLine_OnScrollValueChanged)
	
	
	local labelBarColumn =_mConfigFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelBarColumn:SetPoint("TOPLEFT", 210, -240)
	labelBarColumn:SetJustifyH("LEFT")
	labelBarColumn:SetJustifyV("TOP")
	labelBarColumn:SetText(L.TextBarColumnSpace);	
	_mBarColumn= CreateFrame("Slider", nil, _mConfigFrame)
	_mBarColumn:SetOrientation("HORIZONTAL")
	_mBarColumn:SetWidth(150)
	_mBarColumn:SetHeight(14)
	_mBarColumn:SetHitRectInsets(0, 0, -10, 0)
	_mBarColumn:SetBackdrop(configSliderBackdrop)
	_mBarColumn:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	_mBarColumn:SetPoint("TOPLEFT", 210, -260)
	_mBarColumn:SetMinMaxValues(0, 50)
	_mBarColumn:SetValueStep(1)
	_mBarColumn:SetValue(0)
	_mBarColumn:SetScript("OnValueChanged", BarColumn_OnScrollValueChanged)
	
	
	_mCBModel = CreateFrame("CheckButton",nil, _mConfigFrame, "UICheckButtonTemplate")
	_mCBModel:SetPoint("TOPLEFT", 30, -290)
	_mCBModel.type = "checkbox"
	_mCBModel:SetChecked(true)
	_mCBModel.text:SetText(L.TextMode)
	_mCBModel:SetScript("OnClick", CBModel_OnClick)	
	
	_mCBModel2 = CreateFrame("CheckButton",nil, _mConfigFrame, "UICheckButtonTemplate")
	_mCBModel2:SetPoint("TOPLEFT", 210, -290)
	_mCBModel2.type = "checkbox"
	_mCBModel2:SetChecked(true)
	_mCBModel2.text:SetText(L.TextMode2)
	_mCBModel2:SetScript("OnClick", CBModel2_OnClick)	
	
	_mCBModel3 = CreateFrame("CheckButton",nil, _mConfigFrame, "UICheckButtonTemplate")
	_mCBModel3:SetPoint("TOPLEFT", 30, -320)
	_mCBModel3.type = "checkbox"
	_mCBModel3:SetChecked(true)
	_mCBModel3.text:SetText(L.TextMode3)
	_mCBModel3:SetScript("OnClick", CBModel3_OnClick)	
	
	
	local labelButtonLoc =_mConfigFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelButtonLoc:SetPoint("TOPLEFT", 30, -350)
	labelButtonLoc:SetJustifyH("LEFT")
	labelButtonLoc:SetJustifyV("TOP")
	labelButtonLoc:SetText(L.ButtonLoc);	
	_mButtonLoc= CreateFrame("Slider", nil, _mConfigFrame)
	_mButtonLoc:SetOrientation("HORIZONTAL")
	_mButtonLoc:SetWidth(150)
	_mButtonLoc:SetHeight(14)
	_mButtonLoc:SetHitRectInsets(0, 0, -10, 0)
	_mButtonLoc:SetBackdrop(configSliderBackdrop)
	_mButtonLoc:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	_mButtonLoc:SetPoint("TOPLEFT", 30, -370)
	_mButtonLoc:SetMinMaxValues(0, 7)
	_mButtonLoc:SetValueStep(1)
	_mButtonLoc:SetValue(0)
	_mButtonLoc:SetScript("OnValueChanged", ButtonLoc_OnScrollValueChanged)
	
	local labelButtonLocSpace =_mConfigFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelButtonLocSpace:SetPoint("TOPLEFT", 210, -350)
	labelButtonLocSpace:SetJustifyH("LEFT")
	labelButtonLocSpace:SetJustifyV("TOP")
	labelButtonLocSpace:SetText(L.ButtonLocSpace);	
	_mButtonLocSpace= CreateFrame("Slider", nil, _mConfigFrame)
	_mButtonLocSpace:SetOrientation("HORIZONTAL")
	_mButtonLocSpace:SetWidth(150)
	_mButtonLocSpace:SetHeight(14)
	_mButtonLocSpace:SetHitRectInsets(0, 0, -10, 0)
	_mButtonLocSpace:SetBackdrop(configSliderBackdrop)
	_mButtonLocSpace:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	_mButtonLocSpace:SetPoint("TOPLEFT", 210, -370)
	_mButtonLocSpace:SetMinMaxValues(0, 50)
	_mButtonLocSpace:SetValueStep(1)
	_mButtonLocSpace:SetValue(0)
	_mButtonLocSpace:SetScript("OnValueChanged", ButtonLocSpace_OnScrollValueChanged)
end

function configFrameSetValue(data)
	if data then
		_mConfig = data;
		_mBarLine:SetValue(_mConfig.linespace);
		_mBarWidth:SetValue(_mConfig.barwidth);
		_mBarHight:SetValue(_mConfig.barhigh);
		_mBarColumn:SetValue(_mConfig.columnspace);
		_mBarAlpha:SetValue(_mConfig.colora);
		_mButtonLoc:SetValue(_mConfig.buttonLoc);
		_mButtonLocSpace:SetValue(_mConfig.buttonLocspace);
		_mBarColor:SetColorRGB(_mConfig.colorr,_mConfig.colorg,_mConfig.colorb);
		if _mConfig.printmodel == 0 then
			_mCBModel:SetChecked(false);
		else
			_mCBModel:SetChecked(true);
		end
		if _mConfig.printmodel2 == 0 then
			_mCBModel2:SetChecked(false);
		else
			_mCBModel2:SetChecked(true);
		end
		if _mConfig.printmodel3 == 0 then
			_mCBModel3:SetChecked(false);
		else
			_mCBModel3:SetChecked(true);
		end
		if _mConfig.backup.enabledflag == 0 then
			_mCBDoubleFlag:SetChecked(false);
		else
			_mCBDoubleFlag:SetChecked(true);
		end
	end
end

function Button1_OnClick()
	ShowSetConfig()	
end


function Config_OnMouseDown(xxx)
	_mConfigFrame:StartMoving()
end

function Config_OnMouseUp(xxx)
	_mConfigFrame:StopMovingOrSizing();
end

_mConfigFrame:SetWidth(390)
_mConfigFrame:SetHeight(430)
_mConfigFrame:SetMovable(1);
_mConfigFrame:EnableMouse(1);
_mConfigFrame:SetToplevel(1);
_mConfigFrame:SetBackdrop(configFrameBackdrop);
_mConfigFrame:SetPoint("CENTER","UIParent","CENTER");
_mConfigFrame:SetScript("OnMouseUp",Config_OnMouseUp);
_mConfigFrame:SetScript("OnMouseDown",Config_OnMouseDown);
_mConfigFrame:Hide();

local _mConfigExit = CreateFrame("Button", nil, _mConfigFrame, "UIPanelButtonTemplate");
_mConfigExit:SetScript("OnClick", Button1_OnClick);
_mConfigExit:SetPoint("BOTTOM",_mConfigFrame,"BOTTOM",0,16);
_mConfigExit:SetHeight(20);
_mConfigExit:SetWidth(80);
_mConfigExit:SetText("Exit");