﻿-- Author      : Administrator
-- Create Date : 8/25/2014 6:54:39 PM
if select(2, UnitClass("player")) ~= "PRIEST" then return end
iShieldDB = {}
local _mConfigShow = 1;
local _mLockFlag = 1;
local _mKeepSpellId = 114908; --17
local _mTableInfo = {};
local _mTableSum = 0;
local _mTbaleSubSum = {};
local _mPlayerMaxAura = 1000;
local _mSpecialization = 256;
local _mRaidFlag = 0;
local _mPartyFlag = 0;
local default_settings = {
	barwidth=70;
	barhigh=20;
	columnspace =0;
	linespace = 30;
	buttonLoc=0;
	buttonLocspace=0;
	printmodel=0;
	printmodel2=0;
	printmodel3=0;
	colorr=0.8;
	colorg=0.1;
	colorb=0.1;
	colora=0.6;
	point="CENTER";
	relativePoint="CENTER";
	xOfs=0;
	yOfs=0;
	backup = {
		enabledflag=0;
		point="CENTER";
		relativePoint="CENTER";
		xOfs=0;
		yOfs=0;
		barwidth=70;
		barhigh=20;
		columnspace =0;
		linespace = 30;
	}
}
local typedefTable = {
	activation = false;
	subgroup = 0;
	subgroupvr = 0;
	partyindex = 0;
	bar = nil;
	barpoinx = 0;
	barpoiny = 0;
	nowvalue = 1;
}
local backdrop_move ={ bgFile = "",
						edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
						tile = true, tileSize = 16, edgeSize = 16, 
						insets = { left = 4, right = 4, top = 4, bottom = 4 }};
local _mMainFrame = CreateFrame("Frame","mainFrame",UIParent)
local _mButtonSet = CreateFrame("Frame",nil,UIParent);
local _mButtonLock = CreateFrame("Frame",nil,UIParent);
local _mButtonDoubleConfig = CreateFrame("Frame",nil,UIParent);
do
	local i = 1;
	while i <= 40 do
		local temp ={
			activation = false;
			subgroup = 0;
			partyindex = 0;
			bar = nil;
			barpoinx = 0;
			barpoiny = 0;
			nowvalue = 1};
		_mTableInfo[i] = temp;
		i = i + 1
	end
	i = 1;
	while i <= 8 do
		_mTbaleSubSum[i] = 0;
		i = i + 1;
	end
	_mTableSum =0;
end


function ShowSetConfig()	
	if _mConfigShow == 0 then
		if _mLockFlag == 1 then
			LockFrame()
		end
		_mConfigShow = 1;	
		configFrameSetValue(default_settings)
		getglobal("Config"):Show();
	else
		_mConfigShow = 0;
		if _mLockFlag == 0 then
			LockFrame()
		end
		getglobal("Config"):Hide();
	end
end

function LockFrame()
	if _mConfigShow == 1 then 
		return
	end
	if ( _mLockFlag == 1 ) then
		--_mMainFrame:SetMovable(1);
		_mMainFrame:EnableMouse(1)
		_mLockFlag=0;
		_mMainFrame:SetBackdrop(backdrop_move);
		_mMainFrame:UnregisterEvent("UNIT_AURA");	
		local i = 1;	
		while i <= _mTableSum do
			_mTableInfo[i]["nowvalue"] = default_settings.barwidth;
			i = i + 1;	
		end
		refreshFrameBar();
	else
		--_mMainFrame:SetMovable(0);
		_mMainFrame:EnableMouse(0)
		_mLockFlag=1;
		_mMainFrame:SetBackdrop(nil);
		_mMainFrame:RegisterEvent("UNIT_AURA");
		local i = 1;
		while i <= _mTableSum do
			_mTableInfo[i]["nowvalue"] = 1;
			i = i + 1;	
		end
		refreshFrameBar();
	end
end		

function SwitchConfig()
	if _mConfigShow == 1 then
		ShowSetConfig();
	end
	local temp = {
		point=default_settings.point;
		relativePoint=default_settings.relativePoint;
		xOfs=default_settings.xOfs;
		yOfs=default_settings.yOfs;
		barwidth=default_settings.barwidth;
		barhigh=default_settings.barhigh;
		columnspace =default_settings.columnspace;
		linespace = default_settings.linespace;
	}
	default_settings.point=default_settings.backup.point;
	default_settings.relativePoint=default_settings.backup.relativePoint;
	default_settings.xOfs=default_settings.backup.xOfs;
	default_settings.yOfs=default_settings.backup.yOfs;
	default_settings.barwidth=default_settings.backup.barwidth;
	default_settings.barhigh=default_settings.backup.barhigh;
	default_settings.columnspace=default_settings.backup.columnspace;
	default_settings.linespace=default_settings.backup.linespace;
	
	default_settings.backup.point=temp.point;
	default_settings.backup.relativePoint=temp.relativePoint;
	default_settings.backup.xOfs=temp.xOfs;
	default_settings.backup.yOfs=temp.yOfs;
	default_settings.backup.barwidth=temp.barwidth;
	default_settings.backup.barhigh=temp.barhigh;
	default_settings.backup.columnspace=temp.columnspace;
	default_settings.backup.linespace=temp.linespace;
	
	refreshFrameSize();
	refreshFrameBar();
	iShieldDB = default_settings;
end




function addDefaultOptions(t1, t2)
	for i, v in pairs(t2) do
		if t1[i] == nil then
			t1[i] = v
		elseif type(v) == "table" and type(t1[i]) == "table" then
			addDefaultOptions(t1[i], v)
		end
	end
end


function newFrameBar()
	local i = 1;
	while i <= 40 do
		local _tempbar = CreateFrame("Frame",nil,_mMainFrame)		
		_tempbar:SetFrameStrata("HIGH")
		_tempbar:SetWidth(default_settings.barwidth) 
		_tempbar:SetHeight(default_settings.barhigh)
		local _temp = _tempbar:CreateTexture(nil,"BACKGROUND");
		--_temp:SetTexture(0.8,0.1,0.1,0.6);
		--_temp:SetTexture("INTERFACE\\GLUES\\AccountUpgrade\\golden-h.blp",true);
		--_temp:SetTexCoord(0,1,0,1);
		_temp:SetAllPoints(_tempbar);
		_tempbar.texture = _temp;
		_mTableInfo[i]["bar"] = _temp;
		i = i + 1;	
	end
end

function SaveFrameLoc()
	if default_settings.printmodel3 == 0 then
		default_settings.xOfs = _mMainFrame:GetLeft();
		default_settings.yOfs= _mMainFrame:GetTop();
	else
		if default_settings.printmodel == 0 then
			default_settings.xOfs = _mMainFrame:GetRight();
			default_settings.yOfs= _mMainFrame:GetTop();	
		else
			default_settings.xOfs = _mMainFrame:GetLeft();
			default_settings.yOfs= _mMainFrame:GetBottom();
		end
	end
	iShieldDB = default_settings;
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(default_settings.xOfs).."--"..tostring(default_settings.yOfs));
	--default_settings.point,_,default_settings.relativePoint,default_settings.xOfs,default_settings.yOfs= _mMainFrame:GetPoint();
	
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(xOfs).."--"..tostring(yOfs).."--"..wwww);
end

function printValue(_index,_val)
--DEFAULT_CHAT_FRAME:AddMessage(tostring(_index)..":".._val);
	--local nowval = 0;
	if _index and _mTableInfo[_index]["activation"] == true and _mTableInfo[_index]["nowvalue"] ~= _val then
		_mTableInfo[_index]["nowvalue"] = _val;
		local printval = 1;
		
		_mPlayerMaxAura = UnitHealthMax("player");
		if _mPlayerMaxAura <= 0 then
			_mPlayerMaxAura = 100;
		end		
		_mPlayerMaxAura = math.ceil(_mPlayerMaxAura * 0.6);
		
		printval = (_val / _mPlayerMaxAura) * default_settings.barwidth;
		printval = math.ceil(printval);
		
		local _tempbar = _mTableInfo[_index]["bar"];
		if printval < 1 then
			_tempbar:Hide();
		else 
			if printval > default_settings.barwidth then
				printval = default_settings.barwidth;
			end
			_tempbar:SetWidth(printval);
			_tempbar:Show();
		end	
	end
end


function refreshFrameBar()
	local i = 1;
	local x = 0;
	local y = 0;
	
	while i <= 40 do
		local _tempbar = _mTableInfo[i]["bar"];
		_tempbar:ClearAllPoints();
		_tempbar:SetTexture(default_settings.colorr, default_settings.colorg,default_settings.colorb,default_settings.colora);		
		if _mTableInfo[i]["activation"] == true then
			local _party = 0;
			if default_settings.printmodel2 == 0 then
				_party = _mTableInfo[i]["subgroup"] - 1;
			else
				_party = _mTableInfo[i]["subgroupvr"] - 1;
			end
			
			if default_settings.printmodel3 == 1 then
				_party = 7 - _party;
			end		
			
			
			if default_settings.printmodel == 0 then
				x = _party * (default_settings.barwidth + default_settings.columnspace);			
				y = (_mTableInfo[i]["partyindex"] -1) * (default_settings.barhigh + default_settings.linespace);
			else
				x = (_mTableInfo[i]["partyindex"] - 1) * (default_settings.barwidth + default_settings.columnspace);
				y = _party * (default_settings.barhigh + default_settings.linespace);
			end

			
			if _mLockFlag == 0 then
				_tempbar:SetWidth(default_settings.barwidth);
				_tempbar:Show();
			else
				_tempbar:SetWidth(0);
				_tempbar:Hide();
			end
			_tempbar:SetHeight(default_settings.barhigh)
			_tempbar:SetPoint("TOPLEFT",_mMainFrame,"TOPLEFT",x,-y);
		else
			_tempbar:Hide();
		end
		i = i + 1;	
	end
	
end

function SetValueConfig(data)
	if data then
		--[[default_settings.barwidth = data.barwidth;
		default_settings.barhigh = data.barhigh;
		default_settings.columnspace = data.columnspace;
		default_settings.linespace = data.linespace;
		default_settings.colorr = data.colorr;
		default_settings.colorg = data.colorg;
		default_settings.colorb = data.colorb;
		default_settings.colora = data.colora;	]]	
		refreshFrameSize();
		refreshFrameBar();
		iShieldDB = default_settings;
	end
end

function SetValueConfigModel(data)
	if data then
		--[[default_settings.printmodel = data.printmodel;
		default_settings.printmodel2 = data.printmodel2;
		default_settings.printmodel3 = data.printmodel3;]]
		_mMainFrame:ClearAllPoints();
		_mMainFrame:SetPoint("CENTER","UIParent","CENTER",0,0);
		SaveFrameLoc();
		refreshFrameSize();
		refreshFrameBar();
		iShieldDB = default_settings;
	end
end

function SetValueConfigButton(data)
	if data then
		--[[default_settings.buttonLoc = data.buttonLoc;
		default_settings.buttonLocspace = data.buttonLocspace;
		default_settings.backup.enabledflag = data.backup.enabledflag;]]
		PrintButton();
		iShieldDB = default_settings;
	end
end

function refreshRaid()
	local i = 1;
	_mTableSum = 0;	
	while i <= 8 do
		_mTbaleSubSum[i] = 0;
		i = i + 1;
	end
	
	i = 1
	while i <= 40 do
		_mTableInfo[i]["activation"] = false;
		i = i + 1
	end
	i = 1;
	local playname,_,subgroup = GetRaidRosterInfo(i);
	while playname do
		_mTbaleSubSum[subgroup] = _mTbaleSubSum[subgroup] + 1;
		_mTableInfo[i]["activation"] = true;
		_mTableInfo[i]["subgroup"] = subgroup;
		_mTableInfo[i]["subgroupvr"] = subgroup;
		_mTableInfo[i]["partyindex"] = _mTbaleSubSum[subgroup];
		i = i + 1;
		playname,_,subgroup = GetRaidRosterInfo(i);
	end
	_mTableSum = i-1;

	
	i = 1;
	local subcount = 0;
	while i <= 8 do
		if _mTbaleSubSum[i] > 0 then
			subcount = i;
		end
		i = i + 1;
	end
	
	i = 1;
	while i <=subcount do
		if _mTbaleSubSum[i] == 0 then
			local j = 1;
			while j <= _mTableSum do
				if _mTableInfo[j]["subgroup"] > i then
					 _mTableInfo[j]["subgroupvr"] =  _mTableInfo[j]["subgroupvr"] -1;
				end
				j = j+1;
			end
		end
		i = i + 1;
	end

	--[[i = 1;
	while i <= _mTableSum do
		DEFAULT_CHAT_FRAME:AddMessage(i.." ".._mTableInfo[i]["subgroup"].."(".._mTableInfo[i]["subgroupvr"]..")-".._mTableInfo[i]["partyindex"]);
		i = i + 1;
	end]]
	--DEFAULT_CHAT_FRAME:AddMessage("refreshRaid end");
end



function refreshFrameSize()
	local high = 0;
	local wide = 0;
	_mMainFrame:ClearAllPoints();
	if default_settings.printmodel == 0 then
		high = (default_settings.barhigh + default_settings.linespace) * 5;
		wide = default_settings.barwidth * 8 + default_settings.columnspace * 7;
	else
		high = default_settings.barhigh * 8 + default_settings.linespace * 8;
		wide = default_settings.barwidth * 5 + default_settings.columnspace * 4;
	end
	_mMainFrame:SetSize(wide,high)
	if default_settings.printmodel3 == 0 then
		_mMainFrame:SetPoint("TOPLEFT", "UIParent","BOTTOMLEFT",default_settings.xOfs, default_settings.yOfs);
	else
		if default_settings.printmodel == 0 then
			_mMainFrame:SetPoint("TOPRIGHT", "UIParent","BOTTOMLEFT",default_settings.xOfs, default_settings.yOfs);			
		else
			_mMainFrame:SetPoint("BOTTOMLEFT", "UIParent","BOTTOMLEFT",default_settings.xOfs, default_settings.yOfs);
		end
	end
	
	--_mMainFrame:SetPoint("TOPLEFT", 100, 100);
	--_mMainFrame:SetPoint(default_settings.point,"UIParent",default_settings.relativePoint,default_settings.xOfs,default_settings.yOfs);
end

function PrintButton()
	_mButtonSet:ClearAllPoints();
	_mButtonLock:ClearAllPoints();
	_mButtonDoubleConfig:ClearAllPoints();
	if ( default_settings.buttonLoc == 0 ) then
		_mButtonSet:SetPoint("TOPRIGHT",_mMainFrame,"TOPLEFT",-default_settings.buttonLocspace,0);
		_mButtonLock:SetPoint("TOP",_mButtonSet,"BOTTOM");
		_mButtonDoubleConfig:SetPoint("TOP",_mButtonLock,"BOTTOM");
	elseif ( default_settings.buttonLoc == 1 ) then
		_mButtonSet:SetPoint("BOTTOMLEFT",_mMainFrame,"TOPLEFT",0,default_settings.buttonLocspace);
		_mButtonLock:SetPoint("LEFT",_mButtonSet,"RIGHT");
		_mButtonDoubleConfig:SetPoint("LEFT",_mButtonLock,"RIGHT");
	elseif ( default_settings.buttonLoc == 2 ) then
		_mButtonSet:SetPoint("BOTTOMRIGHT",_mMainFrame,"TOPRIGHT",0,default_settings.buttonLocspace);
		_mButtonLock:SetPoint("RIGHT",_mButtonSet,"LEFT");
		_mButtonDoubleConfig:SetPoint("RIGHT",_mButtonLock,"LEFT");
	elseif ( default_settings.buttonLoc == 3 ) then
		_mButtonSet:SetPoint("TOPLEFT",_mMainFrame,"TOPRIGHT",default_settings.buttonLocspace,0);
		_mButtonLock:SetPoint("TOP",_mButtonSet,"BOTTOM");
		_mButtonDoubleConfig:SetPoint("TOP",_mButtonLock,"BOTTOM");
	elseif ( default_settings.buttonLoc == 4 ) then
		_mButtonSet:SetPoint("BOTTOMLEFT",_mMainFrame,"BOTTOMRIGHT",default_settings.buttonLocspace,0);
		_mButtonLock:SetPoint("BOTTOM",_mButtonSet,"TOP");
		_mButtonDoubleConfig:SetPoint("BOTTOM",_mButtonLock,"TOP");
	elseif ( default_settings.buttonLoc == 5 ) then
		_mButtonSet:SetPoint("TOPRIGHT",_mMainFrame,"BOTTOMRIGHT",0,-default_settings.buttonLocspace);
		_mButtonLock:SetPoint("RIGHT",_mButtonSet,"LEFT");
		_mButtonDoubleConfig:SetPoint("RIGHT",_mButtonLock,"LEFT");
	elseif ( default_settings.buttonLoc == 6 ) then
		_mButtonSet:SetPoint("TOPLEFT",_mMainFrame,"BOTTOMLEFT",0,-default_settings.buttonLocspace);
		_mButtonLock:SetPoint("LEFT",_mButtonSet,"RIGHT");
		_mButtonDoubleConfig:SetPoint("LEFT",_mButtonLock,"RIGHT");
	else
		_mButtonSet:SetPoint("BOTTOMRIGHT",_mMainFrame,"BOTTOMLEFT",-default_settings.buttonLocspace,0);
		_mButtonLock:SetPoint("BOTTOM",_mButtonSet,"TOP");
		_mButtonDoubleConfig:SetPoint("BOTTOM",_mButtonLock,"TOP");
	end
	if default_settings.backup.enabledflag == 0 then
		_mButtonDoubleConfig:Hide();
	else
		_mButtonDoubleConfig:Show();
	end
	_mButtonSet:Show();
	_mButtonLock:Show();
end
          
function restore()
	--[[getglobal(_mMainFrame):Hide();
	getglobal("Button_set"):Hide();
	getglobal("Button_lock"):Hide();
	_mButtonSet:Hide();
	_mButtonLock:Hide();]]
	_mMainFrame:ClearAllPoints();
	_mMainFrame:SetSize(200,200);
	_mMainFrame:SetPoint("CENTER","UIParent","CENTER",0,0);
end

function checkSpec()
	local currentSpec = GetSpecialization()
	local currentSpecName = currentSpec and select(1, GetSpecializationInfo(currentSpec)) or "None"
	if currentSpecName == _mSpecialization then
		_mMainFrame:RegisterEvent("GROUP_ROSTER_UPDATE");
		_mMainFrame:RegisterEvent("UNIT_AURA");
		_mMainFrame:Show();
		_mButtonSet:Show();
		_mButtonLock:Show();
		if default_settings.backup.enabledflag ~= 0 then
			_mButtonDoubleConfig:Show();
		end
		refreshRaid();
		refreshFrameBar();
	else
		_mMainFrame:UnregisterEvent("GROUP_ROSTER_UPDATE");
		_mMainFrame:UnregisterEvent("UNIT_AURA");
		_mMainFrame:Hide();
		_mButtonSet:Hide();
		_mButtonLock:Hide();
		_mButtonDoubleConfig:Hide();
		getglobal("Config"):Hide();
	end
end 

function Frame1_OnEvent(self, event, ...)
	--DEFAULT_CHAT_FRAME:AddMessage(event)
	if event == "UNIT_AURA" then
		local playername = select(1, ...);
		local raidindex = 0;
		if _mRaidFlag == 1 then
			local _,findflag = string.find(playername, "raid");
			if findflag > 0 then
				raidindex = UnitInRaid(playername);
			end			
		else			
			if _mPartyFlag == 1 and playername ~= "target" then
				raidindex = 1;
				if playername ~= "player" then
					raidindex = tonumber(string.sub(playername, 6, 6)) + 1;					
				end
			end
		end
		if raidindex > 0 then
			local indexflag = 1
			local _, _, _, _, _, _, _, _, _, _, spellID, _, _, _, buffvalue = UnitBuff(..., indexflag,  "player")
			local flag = 0
			while spellID do
				if ( spellID == _mKeepSpellId ) then flag = 1 break 
				else indexflag = indexflag + 1 
					_, _, _, _, _, _, _, _, _, _, spellID, _, _, _, buffvalue = UnitBuff(..., indexflag,  "player")
				end
			end	
			if (flag ~= 1) then
				buffvalue = 0;
			end
			
			printValue(raidindex,buffvalue)
		end
		--[[local buffvalue = select(15,UnitAura(...,GetSpellInfo(_mKeepSpellId), nil, "PLAYER"));
		local raidindex = UnitInRaid(...);
		if buffvalue then
		else  
		DEFAULT_CHAT_FRAME:AddMessage(type(buffvalue));
			buffvalue = 0;
		end
		DEFAULT_CHAT_FRAME:AddMessage(tostring(raidindex)..":"..buffvalue);]]

		--[[local buffindex = 1;
		local buffvalue = 0;
		if UnitBuff(...,GetSpellInfo(_mKeepSpellId)) then
			local buffid = select(11,UnitBuff(...,buffindex,"player"));			
			while buffid do
				if _mKeepSpellId == buffid then
					buffvalue = select(15,UnitBuff(...,buffindex,"player"));
					break;
				end
				buffindex = buffindex + 1;
				buffid = select(11,UnitBuff(...,buffindex,"player"));
			end
		end]]		
		--DEFAULT_CHAT_FRAME:AddMessage(tostring(raidindex)..":"..buffvalue);
	else
		if event == "GROUP_ROSTER_UPDATE" then
			local tempflag = UnitInRaid("player");
			if tempflag and tempflag > 0 then
				_mRaidFlag = 1;
			else
				_mRaidFlag = 0;
				tempflag = UnitInParty("player");
				if tempflag and tempflag > 0 then
					_mPartyFlag = 1;
				else
					_mPartyFlag = 0;
				end
			end
			refreshRaid();
			refreshFrameBar();
		else
			if event == "PLAYER_TALENT_UPDATE" then
				checkSpec();
			else
				if event == "ADDON_LOADED" and select(1, ...) == "iShield" then
					if iShieldDB then
						local settings = default_settings;
						default_settings = iShieldDB;
						addDefaultOptions(default_settings, settings);			
						_mMainFrame:UnregisterEvent("ADDON_LOADED");
					end
					refreshFrameSize();
					newFrameBar();
					PrintButton();
					LockFrame();
					configNewFrameBar();
					checkSpec();
				end
			end
		end
	end
end
function Frame1_OnLoad()
	SLASH_HELLOWOXX1 = "/ishield"; 
	SLASH_HELLOWOXX2 = "/is"; 
	SlashCmdList["HELLOWOXX"] = restore;
	_mConfigShow = 0;
	_mLockFlag = 0;
	_mMainFrame:SetPoint("TOPLEFT","UIParent","TOPLEFT");
	_mMainFrame:SetScript("OnEvent", Frame1_OnEvent);
	_mMainFrame:RegisterEvent("ADDON_LOADED");
	_mMainFrame:RegisterEvent("GROUP_ROSTER_UPDATE");
	_mMainFrame:RegisterEvent("PLAYER_TALENT_UPDATE");
end



function Frame1_OnMouseDown(mover)
	_mMainFrame:StartMoving()
end

function Frame1_OnMouseUp(mover)
	_mMainFrame:StopMovingOrSizing();	
	SaveFrameLoc();
end



_mMainFrame:SetWidth(16) 
_mMainFrame:SetHeight(16)
_mMainFrame:SetMovable(1);
_mMainFrame:SetToplevel(1);
Frame1_OnLoad();
--_mMainFrame:SetScript("OnLoad",Frame1_OnLoad);
_mMainFrame:SetScript("OnMouseUp",Frame1_OnMouseUp);
_mMainFrame:SetScript("OnMouseDown",Frame1_OnMouseDown);



_mButtonSet:SetFrameStrata("BACKGROUND")
_mButtonSet:SetWidth(16) -- Set these to whatever height/width is needed 
_mButtonSet:SetHeight(16) -- for your Texture
local _mButtonSetF = _mButtonSet:CreateTexture(nil,"BACKGROUND")
_mButtonSetF:SetTexture("INTERFACE\\GLUES\\CharacterSelect\\Glues-AddOn-Icons.blp",true)
_mButtonSetF:SetTexCoord(0.75,1,0,1);
_mButtonSetF:SetAllPoints(_mButtonSet)
_mButtonSet.texture = _mButtonSetF
_mButtonSet:SetScript("OnMouseDown",ShowSetConfig);


_mButtonLock:SetFrameStrata("BACKGROUND")
_mButtonLock:SetWidth(16) -- Set these to whatever height/width is needed 
_mButtonLock:SetHeight(16) -- for your Texture
local _mButtonLockF = _mButtonLock:CreateTexture(nil,"BACKGROUND")
_mButtonLockF:SetTexture("INTERFACE\\GLUES\\CharacterSelect\\Glues-AddOn-Icons.blp",true)
_mButtonLockF:SetTexCoord(0,0.25,0,1);
_mButtonLockF:SetAllPoints(_mButtonLock)
_mButtonLock.texture = _mButtonLockF
_mButtonLock:SetScript("OnMouseDown",LockFrame);

_mButtonDoubleConfig:SetFrameStrata("BACKGROUND")
_mButtonDoubleConfig:SetWidth(16) -- Set these to whatever height/width is needed 
_mButtonDoubleConfig:SetHeight(16) -- for your Texture
local _mButtonDoubleConfigF = _mButtonDoubleConfig:CreateTexture(nil,"BACKGROUND")
_mButtonDoubleConfigF:SetTexture("INTERFACE\\\TARGETINGFRAME\\UI-TargetingFrame-Seal.blp",true)
_mButtonDoubleConfigF:SetTexCoord(0.2,0.8,0.2,0.8);
_mButtonDoubleConfigF:SetAllPoints(_mButtonDoubleConfig)
_mButtonDoubleConfig.texture = _mButtonDoubleConfigF
_mButtonDoubleConfig:SetScript("OnMouseDown",SwitchConfig);

